<?php
//============================================================+
// File name   : tce_page_header.php
// Begin       : 2001-09-18
// Last Update : 2006-06-19
// 
// Description : output default XHTML page header
//
// Author: Nicola Asuni
//
// (c) Copyright:
//               Nicola Asuni
//               Tecnick.com S.r.l.
//               Via della Pace, 11
//               09044 Quartucciu (CA)
//               ITALY
//               www.tecnick.com
//               info@tecnick.com
//
// License: 
//    Copyright (C) 2004-2008  Nicola Asuni - Tecnick.com S.r.l.
//    
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//    
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//    
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//     
//    Additionally, you can't remove the original TCExam logo, copyrights statements
//    and links to Tecnick.com and TCExam websites.
//    
//    See LICENSE.TXT file for more information.
//============================================================+

/**
 * Outputs default XHTML page header.
 * @package com.tecnick.tcexam.admin
 * @author Nicola Asuni
 * @copyright Copyright &copy; 2004-2008, Nicola Asuni - Tecnick.com S.r.l. - ITALY - www.tecnick.com - info@tecnick.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * @link www.tecnick.com
 * @since 2001-09-18
 * @uses tce_xhtml_header.php
 */

/**
 */

require_once('tce_xhtml_header.php');

// display header (image logo + timer)
echo "<div class=\"header\">\n";
echo "<div class=\"left\"></div>\n";
echo "<div class=\"right\">\n";
echo "<a name=\"timersection\" id=\"timersection\"></a>";
include('../../shared/code/tce_page_timer.php');
echo "</div>\n";
echo "</div>\n";

echo "<div class=\"body\">\n";

// display menu
echo "<div id=\"scrollayer\" class=\"scrollmenu\">";
include('tce_page_menu.php');
echo "</div>\n";

echo "<div class=\"content\">\n";

echo "<a name=\"topofdoc\" id=\"topofdoc\"></a>";

echo "<h1>".htmlspecialchars($thispage_title, ENT_NOQUOTES, $l['a_meta_charset'])."</h1>\n";

//============================================================+
// END OF FILE                                                 
//============================================================+
?>
