<?php
//============================================================+
// File name   : tce_test_execute.php
// Begin       : 2004-05-29
// Last Update : 2008-11-25
// 
// Description : execute a specific test
//
// Author: Nicola Asuni
//
// (c) Copyright:
//               Nicola Asuni
//               Tecnick.com S.r.l.
//               Via della Pace, 11
//               09044 Quartucciu (CA)
//               ITALY
//               www.tecnick.com
//               info@tecnick.com
//
// License: 
//    Copyright (C) 2004-2008  Nicola Asuni - Tecnick.com S.r.l.
//    
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//    
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//    
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//     
//    Additionally, you can't remove the original TCExam logo, copyrights statements
//    and links to Tecnick.com and TCExam websites.
//    
//    See LICENSE.TXT file for more information.
//============================================================+

/**
 * Execute a specific test.
 * @package com.tecnick.tcexam.public
 * @author Nicola Asuni
 * @copyright Copyright &copy; 2004-2008, Nicola Asuni - Tecnick.com S.r.l. - ITALY - www.tecnick.com - info@tecnick.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * @link www.tecnick.com
 * @since 2004-05-29
 * @uses F_executeTest
 */

/**
 */

require_once('../config/tce_config.php');

$pagelevel = 1;
$thispage_title = $l['t_test_execute'];
$thispage_description = $l['hp_test_execute'];
require_once('../../shared/code/tce_authorization.php');
require_once('../../shared/code/tce_functions_form.php');

$formname = "testform";

$test_id = 0;
$testlog_id = 0;
$answer_id = 0;
$answer_text = '';
$test_comment = '';

if (isset($_REQUEST['testid']) AND ($_REQUEST['testid'] > 0)) {
	$test_id = intval($_REQUEST['testid']);
	if (isset($_REQUEST['testlogid']) AND ($_REQUEST['testlogid'] > 0)) {
		$testlog_id = intval($_REQUEST['testlogid']);
	}
	require_once('../../shared/code/tce_functions_test.php');
	
	if (F_executeTest($test_id)) {
		
		if (isset($_REQUEST['forceterminate']) AND (!empty($_REQUEST['forceterminate']))) {
			// terminate the test (lock the test to status=4
			F_terminateUserTest($test_id);
			// logout the user
			require_once('tce_logout.php');
			exit;
		}
		
		// the user is authorized to execute the selected test
		$thispage_title .= ": ".F_getTestName($test_id);
		
		require_once('../code/tce_page_header.php');
		echo "<div class=\"container\">\n";
		
		echo "<span class=\"infolink\">[".F_testInfoLink($test_id, $l['w_info'])."]<br /><br /></span>\n";
		
		if (!isset($_REQUEST['terminationform'])) {
			if (F_isRightTestlogUser($test_id, $testlog_id)) {
				// the form has been submitted, update testlogid data
				if (isset($_REQUEST['answerid']) AND ($_REQUEST['answerid'] > 0)) {
					$answer_id = $_REQUEST['answerid'];
				}
				if (isset($_REQUEST['answertext']) AND (!empty($_REQUEST['answertext']))) {
					$answer_text = $_REQUEST['answertext'];
				}
				if (isset($_REQUEST['reaction_time']) AND ($_REQUEST['reaction_time'] > 0)) {
					$reaction_time = intval($_REQUEST['reaction_time']);
				} else {
					$reaction_time = 0;
				}
				
				F_updateQuestionLog($test_id, $testlog_id, $answer_id, $answer_text, $reaction_time);
				
				// update user's test comment
				if (isset($_REQUEST['testcomment']) AND (!empty($_REQUEST['testcomment']))) {
					$test_comment = $_REQUEST['testcomment'];
					F_updateTestComment($test_id, $test_comment);
				}
				
				if ((isset($_REQUEST['nextquestion']) OR (isset($_REQUEST['autonext']) AND ($_REQUEST['autonext'] == 1))) AND ($_REQUEST['nextquestionid'] > 0)) {
					$testlog_id = 0 + intval($_REQUEST['nextquestionid']);
				} elseif (isset($_REQUEST['prevquestion']) AND ($_REQUEST['prevquestionid'] > 0)) {
					$testlog_id = intval($_REQUEST['prevquestionid']);
				} else {
					while(list($key,$value) = each($_POST)) {
						if (preg_match("/jumpquestion_([0-9]+)/", $key, $matches) > 0) {
							$testlog_id = intval($matches[1]);
							break;
						}
					}
				}
			}
		}
		// confirmation form to terminate the test
		if (isset($_REQUEST['terminatetest']) AND (!empty($_REQUEST['terminatetest']))) {
			F_print_error('WARNING', $l['m_confirm_test_termination']);
			?>
			<div class="confirmbox">
			<form action="<?php echo $_SERVER['SCRIPT_NAME']; ?>" method="post" enctype="multipart/form-data" id="form_test_terminate">
			<div>
			<input type="hidden" name="testid" id="testid" value="<?php echo $test_id; ?>" />
			<input type="hidden" name="testlogid" id="testlogid" value="<?php echo $testlog_id; ?>" />
			<input type="hidden" name="terminationform" id="terminationform" value="1" />
			<?php 
			F_submit_button("forceterminate", $l['w_terminate'], $l['w_terminate_exam']);
			F_submit_button("cancel", $l['w_cancel'], $l['h_cancel']);
			?>
			</div>
			</form>
			</div>
			<?php
		} else {
			echo "<form action=\"".$_SERVER['SCRIPT_NAME']."\" method=\"post\" enctype=\"multipart/form-data\" id=\"".$formname."\"";
			echo " onsubmit=\"var submittime=new Date();document.getElementById('reaction_time').value=submittime.getTime()-document.getElementById('display_time').value;\"";
			echo ">\n";
			echo "<div>\n";
			
			// display questions + navigation menu
			echo F_questionForm($test_id, $testlog_id, $formname);
			
			// the $finish variable is used to check if the form has been automatically submitted
			// at the end of the time.
			if (isset($_REQUEST['finish']) AND ($_REQUEST['finish'] > 0)) {
				$finish = 1;
			} else {
				$finish = 0;
			}
			echo "<input type=\"hidden\" name=\"finish\" id=\"finish\" value=\"".$finish."\" />\n";
			echo "<input type=\"hidden\" name=\"display_time\" id=\"display_time\" value=\"\" />\n";
			echo "<input type=\"hidden\" name=\"reaction_time\" id=\"reaction_time\" value=\"\" />\n";
			
			// textarea field for user's comment
			echo "<span class=\"testcomment\">".F_testComment($test_id)."</span>";
			
			// test termination button
			F_submit_button("terminatetest", $l['w_terminate_exam'], $l['w_terminate_exam']);
			
			echo "\n</div>\n";
			echo "</form>\n";
		}
		
		// start the countdown if disabled
		if (isset($examtime)) {
			echo "<script type=\"text/javascript\">\n";
			echo "//<![CDATA[\n";
			echo "if(!enable_countdown) {\n";
			echo "	FJ_start_timer('true', ".(time() - $examtime).", '".addslashes($l['m_exam_end_time'])."');\n";
			echo "}\n";
			echo "var loadtime=new Date();\n";
			echo "document.getElementById('display_time').value=loadtime.getTime();\n";
			echo "//]]>\n";
			echo "</script>\n";
		}
	}
} else {
	require_once('../code/tce_page_header.php');
	echo "<div class=\"container\">\n";
}

echo "<div class=\"pagehelp\">".$l['hp_test_execute']."</div>\n";

echo "</div>\n"; // container

require_once('../code/tce_page_footer.php');

//============================================================+
// END OF FILE                                                 
//============================================================+
?>
